diff --git a/platform/linux-dpdk/Makefile.am b/platform/linux-dpdk/Makefile.am
index 067c0bb..f9f31c6 100644
--- a/platform/linux-dpdk/Makefile.am
+++ b/platform/linux-dpdk/Makefile.am
@@ -8,15 +8,7 @@ nodist_pkgconfig_DATA = $(top_builddir)/pkgconfig/libodp.pc
 
 .PHONY: pkgconfig/libodp.pc
 
-RTE_SDK    ?= $(top_srcdir)/../dpdk
-RTE_OUTPUT ?= $(RTE_SDK)/build
-RTE_LIB    ?= $(RTE_OUTPUT)/lib
-
-PLAT_CFLAGS  = -include $(RTE_OUTPUT)/include/rte_config.h
-PLAT_CFLAGS += -I$(RTE_OUTPUT)/include
-PLAT_CFLAGS += -I$(RTE_OUTPUT)/include/arch
-PLAT_CFLAGS += -I$(RTE_OUTPUT)/include/exec-env
-PLAT_CFLAGS += -msse4.2
+PLAT_CFLAGS = -msse4.2
 
 AM_CFLAGS +=  $(PLAT_CFLAGS)
 AM_CFLAGS +=  -I$(srcdir)/include
@@ -25,7 +17,6 @@ AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include
 AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include/api
 AM_CFLAGS +=  -I$(top_srcdir)/include
 
-AM_LDFLAGS += -L$(RTE_LIB)
 VPATH = $(srcdir) $(builddir)
 if ODP_PLATFORM_DPDK
 lib_LTLIBRARIES = $(LIB)/libodp.la


> +PLAT_CFLAGS += -msse4.2
> +
> +AM_CFLAGS +=  $(PLAT_CFLAGS)
> +AM_CFLAGS +=  -I$(srcdir)/include
> +AM_CFLAGS +=  -I$(srcdir)/include/api
> +AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include
> +AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include/api
> +AM_CFLAGS +=  -I$(top_srcdir)/include
> +
> +AM_LDFLAGS += -L$(RTE_LIB)
> +VPATH = $(srcdir) $(builddir)
> +if ODP_PLATFORM_DPDK
> +lib_LTLIBRARIES = $(LIB)/libodp.la
> +DPDK_LIBS="-lintel_dpdk -ldl"
> +LIBS += $(DPDK_LIBS)
> +
> +include_HEADERS = \
> +		  $(top_srcdir)/platform/linux-dpdk/include/api/odp_buffer.h \
> +		  $(top_srcdir)/include/odp.h \
> +		  $(top_srcdir)/include/odp_align.h \
> +		  $(top_srcdir)/include/odp_atomic.h \
> +		  $(top_srcdir)/include/odp_barrier.h \
> +		  $(top_srcdir)/include/odp_buffer_pool.h \
> +		  $(top_srcdir)/include/odp_byteorder.h \
> +		  $(top_srcdir)/include/odp_compiler.h \
> +		  $(top_srcdir)/include/odp_config.h \
> +		  $(top_srcdir)/include/odp_coremask.h \
> +		  $(top_srcdir)/include/odp_debug.h \
> +		  $(top_srcdir)/include/odp_hints.h \
> +		  $(top_srcdir)/include/odp_init.h \
> +		  $(top_srcdir)/include/odp_packet_flags.h \
> +		  $(top_srcdir)/include/odp_packet.h \
> +		  $(top_srcdir)/include/odp_packet_io.h \
> +		  $(top_srcdir)/include/odp_queue.h \
> +		  $(top_srcdir)/include/odp_rwlock.h \
> +		  $(top_srcdir)/include/odp_schedule.h \
> +		  $(top_srcdir)/include/odp_shared_memory.h \
> +		  $(top_srcdir)/include/odp_spinlock.h \
> +		  $(top_srcdir)/include/odp_std_types.h \
> +		  $(top_srcdir)/include/odp_sync.h \
> +		  $(top_srcdir)/include/odp_system_info.h \
> +		  $(top_srcdir)/include/odp_thread.h \
> +		  $(top_srcdir)/include/odp_ticketlock.h \
> +		  $(top_srcdir)/include/odp_time.h \
> +		  $(top_srcdir)/include/odp_timer.h \
> +		  $(top_srcdir)/include/odp_version.h
> +
> +subdirheadersdir = $(includedir)/helper
> +subdirheaders_HEADERS = \
> +			$(top_srcdir)/include/helper/odp_chksum.h \
> +			$(top_srcdir)/include/helper/odp_eth.h \
> +			$(top_srcdir)/include/helper/odp_ip.h \
> +			$(top_srcdir)/include/helper/odp_linux.h \
> +			$(top_srcdir)/include/helper/odp_packet_helper.h \
> +			$(top_srcdir)/include/helper/odp_ring.h \
> +			$(top_srcdir)/include/helper/odp_udp.h
> +
> +__LIB__libodp_la_SOURCES = \
> +			   ../linux-generic/odp_barrier.c \
> +			   odp_buffer.c \
> +			   odp_buffer_pool.c \
> +			   ../linux-generic/odp_coremask.c \
> +			   odp_init.c \
> +			   odp_linux.c \
> +			   odp_packet.c \
> +			   odp_packet_dpdk.c \
> +			   ../linux-generic/odp_packet_flags.c \
> +			   odp_packet_io.c \
> +			   ../linux-generic/odp_packet_socket.c \
> +			   odp_queue.c \
> +			   ../linux-generic/odp_ring.c \
> +			   ../linux-generic/odp_rwlock.c \
> +			   ../linux-generic/odp_schedule.c \
> +			   ../linux-generic/odp_shared_memory.c \
> +			   ../linux-generic/odp_spinlock.c \
> +			   ../linux-generic/odp_system_info.c \
> +			   ../linux-generic/odp_thread.c \
> +			   ../linux-generic/odp_ticketlock.c \
> +			   ../linux-generic/odp_time.c \
> +			   ../linux-generic/odp_timer.c
> +
> +endif
> diff --git a/platform/linux-dpdk/README b/platform/linux-dpdk/README
> new file mode 100644
> index 0000000..69116a7
> --- /dev/null
> +++ b/platform/linux-dpdk/README
> @@ -0,0 +1,70 @@
> +ODP-DPDK:
> +---------
> +	This effort is to port ODP on top of DPDK and use dpdk as the
> +accelerator for all intel NIC's. Pre-requisite is DPDK should be cloned and
> +compiled.
> +
> +# To Clone DPDK
> +$ git clone http://92.243.14.124/git/dpdk ./dpdk
> +# Ensure that dpdk is present at the same directory level as odp, that is, ./odp and ./dpdk
> +# we support only 1.6.0r2 of dpdk for now
> +$ git tag -l -- will list all the tags available
> +$ git checkout tags/v1.6.0r2

Oh right I wasn't able to build dpdk I'm using Ubuntu-14.04 with kernel
3.13.0-30-generic

I had to do this change to dpdk:

 $ git df
diff --git a/lib/librte_eal/linuxapp/kni/ethtool/igb/kcompat.h b/lib/librte_eal/linuxapp/kni/ethtool/igb/kcompat.h
index 19df483..78a794a 100644
--- a/lib/librte_eal/linuxapp/kni/ethtool/igb/kcompat.h
+++ b/lib/librte_eal/linuxapp/kni/ethtool/igb/kcompat.h
@@ -3845,11 +3845,6 @@ static inline struct sk_buff *__kc__vlan_hwaccel_put_tag(struct sk_buff *skb,
 #if ( LINUX_VERSION_CODE < KERNEL_VERSION(3,14,0) )
 #ifdef NETIF_F_RXHASH
 #define PKT_HASH_TYPE_L3 0
-static inline void
-skb_set_hash(struct sk_buff *skb, __u32 hash, __always_unused int type)
-{
-       skb->rxhash = hash;
-}
 #endif /* NETIF_F_RXHASH */
 #endif /* < 3.14.0 */